-- written by DaddelZeit
-- DO NOT USE WITHOUT PERMISSION

local M = {}

local function checkKLJPCoremod()
    local jsonData = jsonReadFile("/mods/db.json").mods
    local searchFor = jsonReadFile("/scripts/KLJP_verify_coupeljve/search.json")
    local modname = "1993 200BX Facelift"
    local messageType = "info" -- "info", "warning", "error"

    local foundTable = {}

    for _ ,v in pairs(searchFor) do
        for k2, _ in pairs(jsonData) do
            if not foundTable[v.zip] then
                if k2 == v.zip then
                    foundTable[v.zip] = true
                end
            end
        end
    end

    -- check if mod is installed
    for _, v in pairs(searchFor) do
        if not foundTable[v.zip] then -- not found
            --guihooks.trigger('modmanagerError', modname..' is missing following core mod: "'..v.uiname..'". It may not work correctly!')
            guihooks.trigger('toastrMsg', {
                type = messageType,
                title = modname.." Core Mod Missing",
                msg = modname.." is missing following core mod: "..v.uiname..". "..modname.." may not work correctly!",
                config = {
                    -- require user to acknowledge
                    timeOut = 0,
                    progressBar = false,
                    closeButton = true,

                    -- default stuffs
                    positionClass = 'toast-top-right',
                    preventDuplicates = true,
                    preventOpenDuplicates = true,

                    -- angular gets pissy when i do this so i guess not then
                    -- onTap = [[function() { bngApi.engineLua("extensions.core_repository.uiShowMod('MC7DVKR5T')") }]]
                }
            })
        end
    end

    -- check if mod is enabled
    for _, v in pairs(searchFor) do
        if jsonData[v.zip].active == false then -- not found
            --guihooks.trigger('modmanagerError', 'Following '..modname..' core mod is disabled: "'..v.uiname..'". '..modname..' may not work correctly!')
            guihooks.trigger('toastrMsg', {
                type = messageType,
                title = modname.." Core Mod Disabled",
                msg = "Following "..modname.." core mod is disabled: "..v.uiname..". "..modname.." may not work correctly!",
                config = {
                    -- require user to acknowledge
                    timeOut = 0,
                    progressBar = false,
                    closeButton = true,

                    -- default stuffs
                    positionClass = 'toast-top-right',
                    preventDuplicates = true,
                    preventOpenDuplicates = true,

                    -- angular gets pissy when i do this so i guess not then
                    -- onTap = [[function() { bngApi.engineLua("extensions.core_repository.uiShowMod('MC7DVKR5T')") }]]
                }
            })
        end
    end

    -- core_repository.modSubscribe()
end
M.onExtensionLoaded = function()
    checkKLJPCoremod()
end

M.onFileChanged = function(filename)
    if filename:startswith("/mods/unpacked") then return end
    if filename:startswith("/mods/") and filename:endswith(".json") then -- db.json updated
        checkKLJPCoremod()
    end
end

M.checkKLJPCoremod = checkKLJPCoremod

return M